%define initdir /etc/rc.d/init.d
%define use_alternatives 1

Summary: Common Unix Printing System
Name: cups
Version: 1.1.17
Release: 13.3.55
License: GPL
Group: System Environment/Daemons
Source: ftp://ftp.easysw.com/pub/cups/cups-%{version}-source.tar.bz2
Source1: cups.init
Source2: cupsprinter.png
Source4: cupsconfig
Source5: cups-lpd
Source6: pstoraster
Source7: pstoraster.convs
Source8: postscript.ppd.gz
Source9: cups.logrotate
Source10: ncp.backend
Patch0: cups-1.1.15-initscript.patch
Patch1: cups-1.1.14-doclink.patch
Patch2: cups-1.1.16-system-auth.patch
Patch3: cups-1.1.17-backend.patch
Patch4: cups-1.1.17-uninit.patch
Patch5: cups-idefense-v2.patch
Patch6: cups-1.1.17-pdftops.patch
Patch7: cups-1.1.17-error.patch
Patch8: cups-1.1.17-rcp.patch
Patch9: cups-1.1.17-ppdsdat.patch
Patch10: cups-1.1.17-sigchld.patch
Patch11: cups-1.1.18-str75.patchv2
Patch12: cups-1.1.17-sanity.patch
Patch13: cups-locale.patch
Patch14: cups-1.1.17-loop.patch
Patch15: cups-multiple.patch
Patch16: cups-1.1.19-lpstat.patch
Patch17: cups-1.1.17-usb.patch
Patch18: cups-encryption.patch
Patch19: cups-devnull.patch
Patch20: cups-1.1.17-lpd.patch
Patch21: cups-str242.patch
Patch22: cups-shutdown.patch
Patch23: cups-zero-len-udp-dos.patch
Patch24: cups-str920.patch
Patch25: cups-135378.patch
Patch26: cups-attrs.patch
Patch27: cups-str1023.patch
Patch28: cups-str1024.patch
Patch29: cups-idefense.patch
Patch30: cups-CAN-2005-0064.patch
Patch31: cups-str1068.patch
Patch32: cups-sigchld-reload.patch
Patch33: cups-exit-status.patch
Patch34: cups-accept-language.patch
Patch35: cups-slow.patch
Patch36: cups-fr-templates.patch
Patch37: cups-str700.patch
Patch38: cups-str434.patch
Patch39: cups-eggcups-logging.patch
Patch40: cups-CAN-2005-2097.patch
Patch41: cups-str716.patch
Patch42: cups-conn-closed.patch
Patch43: cups-str371.patch
Patch44: cups-pipe_pid.patch
Patch45: cups-str1301.patch
Patch46: cups-rate-limit-SendBrowseList.patch
Patch47: cups-BrowseInterval-fix.patch
Patch48: cups-finddest.patch
Patch49: cups-IPP_MAX_VALUES.patch
Patch50: cups-CVE-2005-3191_2_3.patch
Patch51: cups-CVE-2005-3625,6,7.patch
Patch52: cups-polling.patch
Patch53: cups-CVE-2007-0720.patch
Patch54: cups-class-failover.patch
Patch55: cups-CVE-2007-3387.patch
Patch56: cups-CVE-2007-5393.patch
Patch57: cups-CVE-2007-4351.patch
Patch58: cups-CVE-2007-4045.patch
Patch59: cups-str2656.patch
Patch60: cups-CVE-2008-0596.patch
Patch61: cups-CVE-2008-0597.patch
Patch62: cups-CVE-2008-0053.patch
Patch63: cups-CVE-2008-1373.patch
Patch64: cups-CVE-2008-1374.patch
Patch65: cups-CVE-2008-1722.patch
Patch66: cups-CVE-2008-3639.patch
Patch67: cups-CVE-2008-3640.patch
Patch68: cups-CVE-2008-3641.patch
Patch69: cups-CVE-2008-5286.patch
Epoch: 1
Url: http://www.cups.org/
BuildRoot: %{_tmppath}/%{name}-root
PreReq: /sbin/chkconfig /sbin/service
Requires: %{name}-libs = %{epoch}:%{version} htmlview xinetd
%if %use_alternatives
Provides: /usr/bin/lpq /usr/bin/lpr /usr/bin/lp /usr/bin/cancel /usr/bin/lprm /usr/bin/lpstat
Prereq: /usr/sbin/alternatives
%endif

# Obsoletes LPRng unconditionally.
Obsoletes: lpd lpr LPRng <= 3.8.15-3
Provides: lpd lpr LPRng = 3.8.15-3

BuildPrereq: pam-devel XFree86-devel openssl-devel pkgconfig

%package devel
Summary: Common Unix Printing System - development environment
Group: Development/Libraries
Requires: %{name}-libs = %{epoch}:%{version}

%package libs
Summary: Common Unix Printing System - libraries
Group: System Environment/Libraries

%description
The Common UNIX Printing System provides a portable printing layer for 
UNIX operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces. 

%description devel
The Common UNIX Printing System provides a portable printing layer for 
UNIX operating systems. This is the development package for creating
additional printer drivers, and other CUPS services.

%description libs
The Common UNIX Printing System provides a portable printing layer for 
UNIX operating systems. It has been developed by Easy Software Products 
to promote a standard printing solution for all UNIX vendors and users. 
CUPS provides the System V and Berkeley command-line interfaces. 
The cups-libs package provides libraries used by applications to use CUPS
natively, without needing the lp/lpr commands.

%prep
%setup -q
%patch0 -p1 -b .noinit
%patch1 -p1 -b .doclink
%patch2 -p1 -b .system-auth
%patch3 -p1 -b .backend
%patch4 -p1 -b .uninit
%patch5 -p0 -b .security
%patch6 -p1 -b .pdftops
%patch7 -p1 -b .error
%patch8 -p1 -b .rcp
%patch9 -p1 -b .ppdsdat
%patch10 -p1 -b .sigchld
%patch11 -p1 -b .str75
%patch12 -p1 -b .sanity
%patch13 -p1 -b .locale
%patch14 -p1 -b .loop
%patch15 -p1 -b .multiple
%patch16 -p1 -b .lpstat
%patch17 -p1 -b .usb
%patch18 -p1 -b .encryption
%patch19 -p1 -b .devnull
%patch20 -p1 -b .lpd
%patch21 -p1 -b .str242
%patch22 -p1 -b .shutdown
%patch23 -p1 -b .zero-len-udp-dos
%patch24 -p1 -b .str920
%patch25 -p1 -b .135378
%patch26 -p1 -b .attrs
%patch27 -p1 -b .str1023
%patch28 -p1 -b .str1024
%patch29 -p1 -b .idefense
%patch30 -p1 -b .CAN-2005-0064
%patch31 -p1 -b .str1068
%patch32 -p1 -b .sigchld-reload
%patch33 -p1 -b .exit-status
%patch34 -p1 -b .accept-language
%patch35 -p1 -b .slow
%patch36 -p1 -b .fr-templates
%patch37 -p1 -b .str700
%patch38 -p1 -b .str434
%patch39 -p1 -b .eggcups-logging
%patch40 -p1 -b .CAN-2005-2097
%patch41 -p1 -b .str716
%patch42 -p1 -b .conn-closed
%patch43 -p1 -b .str371
%patch44 -p1 -b .pipe_pid
%patch45 -p1 -b .str1301
%patch46 -p1 -b .rate-limit-SendBrowseList
%patch47 -p1 -b .BrowseInterval-fix
%patch48 -p1 -b .finddest
%patch49 -p1 -b .IPP_MAX_VALUES
%patch50 -p1 -b .CVE-2005-3191_2_3
%patch51 -p1 -b .CVE-2005-3625,6,7
%patch52 -p1 -b .polling
%patch53 -p1 -b .CVE-2007-0720
%patch54 -p1 -b .class-failover
%patch55 -p1 -b .CVE-2007-3387
%patch56 -p1 -b .CVE-2007-5393
%patch57 -p1 -b .CVE-2007-4351
%patch58 -p1 -b .CVE-2007-4045
%patch59 -p1 -b .str2656
%patch60 -p1 -b .CVE-2008-0596
%patch61 -p1 -b .CVE-2008-0597
%patch62 -p1 -b .CVE-2008-0053
%patch63 -p1 -b .CVE-2008-1373
%patch64 -p1 -b .CVE-2008-1374
%patch65 -p1 -b .CVE-2008-1722
%patch66 -p1 -b .CVE-2008-3639
%patch67 -p1 -b .CVE-2008-3640
%patch68 -p1 -b .CVE-2008-3641
%patch69 -p1 -b .CVE-2008-5286
perl -pi -e 's,^#(Printcap\s+/etc/printcap),$1,' conf/cupsd.conf.in
perl -pi -e 's,^#(MaxLogSize\s+0),$1,' conf/cupsd.conf.in
autoconf

cp %{SOURCE5} cups-lpd.real
perl -pi -e "s,\@LIBDIR\@,%{_libdir},g" cups-lpd.real

%build
if pkg-config openssl ; then
  export CFLAGS=`pkg-config --cflags openssl`
  export CPPFLAGS=`pkg-config --cflags-only-I openssl`
  export LDFLAGS=`pkg-config --libs-only-L openssl`
fi
%configure --with-docdir=%{_docdir}/cups-%{version}
perl -pi -e "s,^DSO	=.*,DSO=gcc -fpic," Makedefs

# If we got this far, all prerequisite libraries must be here.
make OPTIM="$RPM_OPT_FLAGS $CFLAGS -fpic"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{initdir}

make BUILDROOT=$RPM_BUILD_ROOT install 

install -m 755 $RPM_SOURCE_DIR/cups.init $RPM_BUILD_ROOT%{initdir}/cups

find $RPM_BUILD_ROOT/usr/share/cups/model -name "*.ppd" |xargs gzip -9f

%if %use_alternatives
pushd $RPM_BUILD_ROOT%{_bindir}
for i in cancel lp lpq lpr lprm lpstat; do
	mv $i $i.cups
done
cd $RPM_BUILD_ROOT%{_sbindir}
mv lpc lpc.cups
cd $RPM_BUILD_ROOT%{_mandir}/man1
for i in lp lpq lpr lprm lpstat; do
	mv $i.1 $i-cups.1
done
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/cancel.1
ln -s lp-cups.1 $RPM_BUILD_ROOT%{_mandir}/man1/cancel-cups.1
cd $RPM_BUILD_ROOT%{_mandir}/man8
mv lpc.8 lpc-cups.8
popd
%endif

mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps $RPM_BUILD_ROOT%{_sysconfdir}/X11/sysconfig $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/System $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -c -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/pixmaps
install -c -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{_bindir}
install -c -m 755 cups-lpd.real $RPM_BUILD_ROOT%{_sysconfdir}/xinetd.d/cups-lpd
install -c -m 755 %{SOURCE9} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/cups
install -c -m 755 %{SOURCE10} $RPM_BUILD_ROOT%{_libdir}/cups/backend/ncp
ln -s ../doc/%{name}-%{version} $RPM_BUILD_ROOT%{_datadir}/%{name}/doc
# Deal with users trying to access the admin tool at
# /usr/share/doc/cups-%{version}/index.html rather than the
# correct http://localhost:631/
for i in admin classes jobs printers; do
	mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/$i
	cat >$RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/$i/index.html <<EOF
<?xml version="1.0"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/transitional.dtd">
<html lang="en" xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="refresh" content="2; URL=http://localhost:631/$i" />
<title>CUPS $i</title>
</head>
<body bgcolor="#cccc99" text="#000000" link="#0000ff" vlink="#ff00ff">
<p>You are trying to access the CUPS admin frontend through reading the files.
The correct way to access the CUPS admin frontend is pointing your browser at
<a href="http://localhost:631/">http://localhost:631/</a>.</p>
<p>You should be automatically redirected to the correct URL in 2 seconds.
If your browser does not support redirection, please use
<a href="http://localhost:631/$i">this link</a>.</p>
</body>
</html>
EOF
done

# Ship pstoraster (bug #69573).
install -c -m 755 %{SOURCE6} $RPM_BUILD_ROOT%{_libdir}/cups/filter
install -c -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{_sysconfdir}/cups

# Ship a generic postscript PPD file (#73061)
install -c -m 644 %{SOURCE8} $RPM_BUILD_ROOT%{_datadir}/cups/model

# Remove unshipped files.
rm -rf $RPM_BUILD_ROOT%{_mandir}/cat? $RPM_BUILD_ROOT%{_mandir}/*/cat?

%post
/sbin/chkconfig --del cupsd 2>/dev/null || true # Make sure old versions aren't there anymore
/sbin/chkconfig --add cups || true
%if %use_alternatives
/usr/sbin/alternatives --install %{_bindir}/lpr print %{_bindir}/lpr.cups 40 \
	 --slave %{_bindir}/lp print-lp %{_bindir}/lp.cups \
	 --slave %{_bindir}/lpq print-lpq %{_bindir}/lpq.cups \
	 --slave %{_bindir}/lprm print-lprm %{_bindir}/lprm.cups \
	 --slave %{_bindir}/lpstat print-lpstat %{_bindir}/lpstat.cups \
	 --slave %{_bindir}/cancel print-cancel %{_bindir}/cancel.cups \
	 --slave %{_sbindir}/lpc print-lpc %{_sbindir}/lpc.cups \
	 --slave %{_mandir}/man1/cancel.1.gz print-cancelman %{_mandir}/man1/cancel-cups.1.gz \
	 --slave %{_mandir}/man1/lp.1.gz print-lpman %{_mandir}/man1/lp-cups.1.gz \
	 --slave %{_mandir}/man8/lpc.8.gz print-lpcman %{_mandir}/man8/lpc-cups.8.gz \
	 --slave %{_mandir}/man1/lpq.1.gz print-lpqman %{_mandir}/man1/lpq-cups.1.gz \
	 --slave %{_mandir}/man1/lpr.1.gz print-lprman %{_mandir}/man1/lpr-cups.1.gz \
	 --slave %{_mandir}/man1/lprm.1.gz print-lprmman %{_mandir}/man1/lprm-cups.1.gz \
	 --slave %{_mandir}/man1/lpstat.1.gz print-lpstatman %{_mandir}/man1/lpstat-cups.1.gz \
	 --initscript cups
%endif
if [ $1 -eq 1 ]; then
  # First install.  Build ppds.dat.
  /sbin/service cups reload >/dev/null 2>&1 || :
fi
exit 0

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%preun
if [ "$1" = "0" ]; then
	/sbin/service cups stop > /dev/null 2>&1
	/sbin/chkconfig --del cups
%if %use_alternatives
        /usr/sbin/alternatives --remove print %{_bindir}/lpr.cups
%endif
fi
exit 0

%postun
if [ "$1" -ge "1" ]; then
	/sbin/service cups condrestart > /dev/null 2>&1
fi
exit 0

%triggerin -- samba-client
ln -sf ../../../bin/smbspool %{_libdir}/cups/backend/smb || :
exit 0

%triggerun -- samba-client
[ $2 = 0 ] || exit 0
rm -f %{_libdir}/cups/backend/smb

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%dir %attr(0755,lp,sys) /etc/cups
%dir %attr(0711,lp,sys) /etc/cups/certs
%config(noreplace) %attr(0600,lp,sys) /etc/cups/classes.conf
%config(noreplace) %attr(0600,lp,sys) /etc/cups/cupsd.conf
%config(noreplace) %attr(0600,lp,sys) /etc/cups/printers.conf
%config(noreplace) /etc/cups/client.conf
/etc/cups/interfaces
%config(noreplace) /etc/cups/mime.types
%config(noreplace) /etc/cups/mime.convs
%dir %attr(0755,lp,sys) /etc/cups/ppd
/etc/cups/pstoraster.convs
/etc/pam.d/cups
%doc %{_docdir}/cups-%{version}
%config(noreplace) %{initdir}/cups
%{_bindir}/cupsconfig
%{_bindir}/cancel*
%{_bindir}/enable*
%{_bindir}/disable*
%{_bindir}/lp*
%{_libdir}/cups
%{_mandir}/man?/*
%{_mandir}/*/man?/*
%{_sbindir}/*
%{_datadir}/cups
%{_datadir}/locale/*/*
%dir %attr(1700,lp,sys) /var/spool/cups/tmp
%dir %attr(0700,lp,sys) /var/spool/cups
%dir %attr(0755,lp,sys) /var/log/cups
%config(noreplace) %{_sysconfdir}/xinetd.d/cups-lpd
%config(noreplace) %{_sysconfdir}/logrotate.d/cups
%{_datadir}/pixmaps/cupsprinter.png

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*

%files devel
%defattr(-,root,root)
%{_bindir}/cups-config
%{_libdir}/*.so
%{_libdir}/*.a
%{_includedir}/cups

%changelog
* Wed Dec  3 2008 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.55
- Applied patch to fix STR #2974 (bug #473905, CVE-2008-5286,
  CVE-2008-1722).

* Tue Sep 30 2008 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.54
- Applied patch to fix CVE-2008-3639 (STR #2918, bug #464718).
- Applied patch to fix CVE-2008-3640 (STR #2919, bug #464718).
- Applied patch to fix CVE-2008-3641 (STR #2911, bug #464718).

* Thu May  1 2008 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.53
- Applied patch to fix CVE-2008-1722 (integer overflow in image filter,
  bug #441692, STR #2790).

* Thu Mar 20 2008 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.52
- Applied patch to fix CVE-2008-0053 (HP-GL/2 input processing, bug #438117).
- Applied patch to fix CVE-2008-1373 (GIF overflow, bug #438303).
- Applied patch to fix CVE-2008-1374 (64-bit PDF crash, bug #438336).

* Thu Feb 21 2008 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.51
- Prevented invalid memory accesses when a class and its singleton printer
  are timed out in the same sweep (CVE-2008-0597, bug #433827).

* Thu Feb 21 2008 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.50
- Back-ported mimeDeleteType from 1.2.x (CVE-2008-0596, bug #433827).

* Thu Feb 21 2008 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.49
- Prevent double-free when a browsed class has the same name as a printer
  or vice versa (bug #433763, STR #2656).

* Mon Feb 18 2008 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.48
- Removed mandatory debugging output from cups-polld (bug #246545), which had
  been introduced by this change:
  - Backported cups-polld fixes (bug #205694).

* Wed Dec 12 2007 Tim Waugh <twaugh@redhat.com>
- Reverted previous change as no security impact (bug #418361).

* Mon Dec 10 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.47
- Applied patch to fix CVE-2007-5848 (bug #418361).

* Tue Oct 30 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.46
- Applied patch to fix CVE-2007-4045 (bug #356541).
- Applied patch to fix CVE-2007-4351 (STR #2561, bug #356541).
- Applied patch to fix CVE-2007-5393 (bug #356541).

* Wed Jul 18 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.45
- Better patch for CVE-2007-3387 (bug #248219).

* Tue Jul 17 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.44
- Applied patch to fix CVE-2007-3387 (bug #248219).

* Mon Mar 26 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.43
- Backported class failover fix from svn4650 (bug #163960).
- Reinstated this change:
  - Backported cups-polld fixes (bug #205694).

* Fri Mar 23 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.42
- Another SSL patch fix (bug #232241).

* Fri Mar 23 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.41
- Fixed SSL patch (bug #232241).

* Tue Mar 20 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.40
- Reverted this change:
  - Backported cups-polld fixes (bug #205694).

* Wed Mar 14 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.39
- Added timeouts to SSL negotiation (bug #232241).

* Thu Jan 18 2007 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.38
- Backported cups-polld fixes (bug #205694).

* Thu Jan  5 2006 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.37
- Reinstated changes:
  - Raise IPP_MAX_VALUES to 100 (bug #164232).
  - Rate limit SendBrowseList() calls (bug #164232).
  - Back-ported BrowseInterval fix from 1.1.23 (bug #164232).
  - Made FindDest better behaved in some instances (bug #164232).
  - Applied patch from STR #1301 (bug #169979).
  - Applied patch from STR #371 (bug #165946).
  - Back-ported http.c code from 1.1.23 to handle connections being closed
    during httpUpdate (bug #161889).  STR #611.
  - Applied patch from STR #716 (bug #161889).

* Wed Jan  4 2006 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.36
- Apply patch to fix CVE-2005-3625, CVE-2005-3626, CVE-2005-3627
  (bug #176868).

* Wed Jan  4 2006 Tim Waugh <twaugh@redhat.com>
- Reverted all changes since 1.1.17-13.3.34.
  REVERTED:
  - Raise IPP_MAX_VALUES to 100 (bug #164232).
  - Rate limit SendBrowseList() calls (bug #164232).
  - Back-ported BrowseInterval fix from 1.1.23 (bug #164232).
  - Made FindDest better behaved in some instances (bug #164232).
  - Applied patch from STR #1301 (bug #169979).
  - Applied patch from STR #371 (bug #165946).
  - Back-ported http.c code from 1.1.23 to handle connections being closed
    during httpUpdate (bug #161889).  STR #611.
  - Applied patch from STR #716 (bug #161889).

* Tue Dec 20 2005 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.35
- Reinstated changes:
  - Raise IPP_MAX_VALUES to 100 (bug #164232).
  - Rate limit SendBrowseList() calls (bug #164232).
  - Back-ported BrowseInterval fix from 1.1.23 (bug #164232).
  - Made FindDest better behaved in some instances (bug #164232).
  - Applied patch from STR #1301 (bug #169979).
  - Applied patch from STR #371 (bug #165946).
  - Back-ported http.c code from 1.1.23 to handle connections being closed
    during httpUpdate (bug #161889).  STR #611.
  - Applied patch from STR #716 (bug #161889).

* Wed Dec 14 2005 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.34
- Applied patch to fix CVE-2005-3191/2/3 (bug #175645).

* Wed Dec 14 2005 Tim Waugh <twaugh@redhat.com>
- Reverted most changes since 1.1.17-13.3.32 for securty update.
  KEPT:
  - Applied patch from STR #1290 (bug #169933).
  REVERTED:
  - Raise IPP_MAX_VALUES to 100 (bug #164232).
  - Rate limit SendBrowseList() calls (bug #164232).
  - Back-ported BrowseInterval fix from 1.1.23 (bug #164232).
  - Made FindDest better behaved in some instances (bug #164232).
  - Applied patch from STR #1301 (bug #169979).
  - Applied patch from STR #371 (bug #165946).
  - Back-ported http.c code from 1.1.23 to handle connections being closed
    during httpUpdate (bug #161889).  STR #611.
  - Applied patch from STR #716 (bug #161889).

* Fri Nov 18 2005 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.33
- Raise IPP_MAX_VALUES to 100 (bug #164232).
- Rate limit SendBrowseList() calls (bug #164232).
- Back-ported BrowseInterval fix from 1.1.23 (bug #164232).
- Made FindDest better behaved in some instances (bug #164232).
- Applied patch from STR #1301 (bug #169979).
- Applied patch from STR #1290 (bug #169933).
- Applied patch from STR #371 (bug #165946).
- Back-ported http.c code from 1.1.23 to handle connections being closed
  during httpUpdate (bug #161889).  STR #611.
- Applied patch from STR #716 (bug #161889).

* Tue Aug  9 2005 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.32
- Reinstated changes:
  - Only log "POST /" requests at LogLevel debug and higher (bug #142320).
  - Close connection on error (bug #161952, STR #434).
  - Applied patch to prevent occasional cupsd crash on reload (bug #146850).
  - Backport upstream patch to fix STR #1068 (bug #146236).
  - Backport upstream patch to fix bug #153065 (jobs cancelled on failure).
  - Backport upstream patch to fix bug #138123 (unwanted multiple copies).
  - Fixed French templates for the web interface (bug #159065).

* Mon Aug  1 2005 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.31
- Fixed CAN-2005-2097 (bug #164510).

* Mon Aug  1 2005 Tim Waugh <twaugh@redhat.com>
- Reverted all changes since 1.1.17-13.3.29 for security update.
  REVERTED:
  - Only log "POST /" requests at LogLevel debug and higher (bug #142320).
  - Close connection on error (bug #161952, STR #434).
  - Applied patch to prevent occasional cupsd crash on reload (bug #146850).
  - Backport upstream patch to fix STR #1068 (bug #146236).
  - Backport upstream patch to fix bug #153065 (jobs cancelled on failure).
  - Backport upstream patch to fix bug #138123 (unwanted multiple copies).
  - Fixed French templates for the web interface (bug #159065).

* Wed Jul 20 2005 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.30
- Only log "POST /" requests at LogLevel debug and higher (bug #142320).
- Close connection on error (bug #161952, STR #434).
- Restored all changes between 1.1.17-13.3.27 and 1.1.17-13.3.28.

* Wed Jul  6 2005 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.29
- Apply patch to fix CAN-2004-2154 (case-sensitive Location matching).
  STR #700 (bug #162405).

* Tue Jul  5 2005 Tim Waugh <twaugh@redhat.com>
- Reverted most changes since 1.1.17-13.3.27 for security update.  Only kept:
  - DeletePrinterFromClass() fixes from bug #160620:
    - Use memmove() instead of memcpy() for removing element from array.
    - Only call SetPrinterAttrs() if we deleted a printer from the class.

* Thu Jun 23 2005 Tim Waugh <twaugh@redhat.com> 1:1.1.17-13.3.28
- Fixed French templates for the web interface (bug #159065).

* Wed Jun 22 2005 Tim Waugh <twaugh@redhat.com>
- DeletePrinterFromClass() fixes from bug #160620:
  - Use memmove() instead of memcpy() for removing element from array.
  - Only call SetPrinterAttrs() if we deleted a printer from the class.

* Tue May  3 2005 Tim Waugh <twaugh@redhat.com>
- Backport upstream patch to fix bug #138123 (unwanted multiple copies).

* Fri Apr 15 2005 Tim Waugh <twaugh@redhat.com>
- Backport upstream patch to fix bug #153065 (jobs cancelled on failure).

* Tue Mar 22 2005 Tim Waugh <twaugh@redhat.com>
- Applied patch to prevent occasional cupsd crash on reload (bug #146850).
- Backport upstream patch to fix STR #1068 (bug #146236).

* Mon Feb  7 2005 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.27
- More fixing of CAN-2004-0888 patch (bug #135378).

* Fri Feb  4 2005 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.26
- Disabled the two bug-fix patches since 1.1.17-13.3.24.  Fixes since
  1.1.17-13.3.24 are:
  - Mark initscript noreplace (bug #145629).
  - Fixed CAN-2004-0888 patch (bug #135378).

* Fri Feb  4 2005 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.25
- Add explicit casting to CAN-2004-0888 (former CESA-2004-007) patch
  to let it work on 64bit machines (originally bug #135378).

* Wed Feb  2 2005 Tim Waugh <twaugh@redhat.com>
- Applied patch to prevent occasional cupsd crash on reload (bug #146850).

* Tue Feb  1 2005 Tim Waugh <twaugh@redhat.com>
- Applied patch to prevent file descriptor confusion (bug #146236).

* Thu Jan 20 2005 Tim Waugh <twaugh@redhat.com>
- Mark initscript noreplace (bug #145629).

* Mon Jan 17 2005 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.24
- Updated CAN-2005-0064 patch (bug #145102).

* Fri Jan 14 2005 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.23
- Applied patch to fix CAN-2005-0064 (bug #145049).

* Thu Jan  6 2005 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.22
- Fixed patch from STR #1023.

* Tue Dec 21 2004 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.21
- iDefense security fix for CAN-2004-1125 (bug #143566).

* Fri Dec 17 2004 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.20
- Use upstream patches for bug #143087.

* Thu Dec 16 2004 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.19
- Fixed STR #1023 (part of bug #143087).
- Fixed STR #1024 (rest of bug #143087).

* Thu Nov 25 2004 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.18
- Backport code change to fix bug #107789.

* Thu Nov 11 2004 Tim Waugh <twaugh@redhat.com>
- Make cancel-cups(1) man page point to lp-cups(1) not lp(1) (bug #136973).

* Wed Oct 20 2004 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.17
- Rebuilt to include cancel-cups man page.

* Tue Oct 19 2004 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.16
- One more overflow check, from Marcus Meissner (bug #135378).

* Tue Oct 12 2004 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.15
- Apply patch to fix CAN-2004-0888 (bug #135378).

* Tue Oct  5 2004 Tim Waugh <twaugh@redhat.com> 1.1.17:13.3.14
- Apply patch to fix CAN-2004-0923 (bug #134599).

* Thu Sep  9 2004 Tim Waugh <twaugh@redhat.com>
- Mark mime.convs and mime.types as config files (bug #99461, bug #132034).
 
* Mon Aug 23 2004 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.13
- Apply patch to fix CAN-2004-0558 (bug #130650).

* Fri Jul 16 2004 Tim Waugh <twaugh@redhat.com>
- Added version to LPRng obsoletes: tag (bug #128024).

* Thu Jun 24 2004 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.12
- Include fix for bug #107787, in which DoS-detection triggers too early.

* Wed Jun 23 2004 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.11
- Avoid using unsafe functions inside SIGCHLD handler (bug #124345).
- Build with STR #242 patch, for bug #124345.

* Tue May 25 2004 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.10
- Backport 1.1.19 fix for lpd.c signal handling (bug #107256, bug #118707).
- Initialize device_uri to "file:/dev/null" when loading saved jobs
  (bug #123003).  Backported from 1.1.20.

* Fri May 14 2004 Tim Waugh <twaugh@redhat.com>
- Fix cups/util.c:get_num_sdests() to use encryption when it is necessary
  or requested (bug #118982).

* Thu Apr 29 2004 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.9
- Build for U3.

* Tue Mar 30 2004 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.8
- Back-port some USB backend fixes from 1.1.20 (bug #106536).
- Increase lpstat time buffer to handle more verbose time zones (bug #119418).

* Fri Mar 26 2004 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.7
- Backport some 1.1.20 fixes to prevent accidental multiple copies
  (bug #104360, bug #118707).

* Mon Sep  1 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.6
- Prevent a libcups busy loop (bug #97958).

* Fri Aug 15 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.5
- Pass correct attributes-natural-language through even in the absence
  of translations for that language (bug #100984).

* Mon Jun 23 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.4
- Start cupsd before nfs server processes (bug #97767).

* Mon Jun 16 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.3
- Don't busy loop in the client if the IPP port is in use by another
  app (bug #97468).

* Tue Jun  3 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.2
- Obsolete LPRng now.

* Wed May 28 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3.1
- Rebuild.

* Thu May 15 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13.3
- Fix typo and rebuild for proper debug stripping.

* Tue May 13 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13.2
- Updated HTTP blocking fix to cups-1.1.18-str75.patchv2.

* Mon May 12 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13.1
- Fix HTTP blocking issue with scheduler: http://www.cups.org/str.php?L75.

* Wed Feb 12 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-13
- Don't set SIGCHLD to SIG_IGN when using wait4 (via pclose) (bug #84101).

* Tue Feb  4 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-12
- Fix cups-lpd (bug #83452).

* Fri Jan 31 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-11
- Build ppds.dat on first install.

* Fri Jan 24 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-10
- Add support for rebuilding ppds.dat without running the scheduler
  proper (for bug #82500).

* Wed Jan 22 2003 Tim Powers <timp@redhat.com> 1.1.17-9
- rebuilt

* Wed Jan 22 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-8
- Warn against editing queues managed by redhat-config-printer
  (bug #82267).

* Wed Jan 22 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-7
- Fix up error reporting in lpd backend.

* Thu Jan  9 2003 Tim Waugh <twaugh@redhat.com> 1.1.17-6
- Add epoch to internal requirements.
- Make 'condrestart' return success exit code when daemon isn't running.

* Tue Jan  7 2003 Nalin Dahyabhai <nalin@redhat.com> 1.1.17-5
- Use pkg-config information to find SSL libraries.

* Thu Dec 19 2002 Tim Waugh <twaugh@redhat.com> 1.1.17-4
- Security fixes.
- Make 'service cups reload' update the configuration first (bug #79953).

* Tue Dec 10 2002 Tim Waugh <twaugh@redhat.com> 1.1.17-3
- Fix cupsd startup hang (bug #79346).

* Mon Dec  9 2002 Tim Waugh <twaugh@redhat.com> 1.1.17-2
- Fix parallel backend behaviour when cancelling jobs.

* Mon Dec  9 2002 Tim Waugh <twaugh@redhat.com> 1.1.17-1
- 1.1.17.
- No longer need libdir patch.
- Fix logrotate script (bug #76791).

* Wed Nov 20 2002 Tim Waugh <twaugh@redhat.com>
- Build requires XFree86-devel (bug #78362).

* Wed Nov 20 2002 Tim Waugh <twaugh@redhat.com>
- 1.1.16.
- Updated system-auth patch.
- Add ncp backend script.

* Wed Nov 13 2002 Tim Waugh <twaugh@redhat.com> 1.1.15-15
- Set alternatives priority to 40.

* Mon Nov 11 2002 Nalin Dahyabhai <nalin@redhat.com> 1.1.15-14
- Buildrequire pam-devel.
- Patch default PAM config file to remove directory names from module paths,
  allowing the configuration files to work equally well on multilib systems.
- Patch default PAM config file to use system-auth, require the file at build-
  time because that's what data/Makefile checks for.

* Fri Nov  8 2002 Tim Waugh <twaugh@redhat.com> 1.1.15-13
- Use logrotate for log rotation (bug #76791).
- No longer need cups.desktop, since redhat-config-printer handles it.

* Thu Oct 17 2002 Tim Waugh <twaugh@redhat.com> 1.1.15-12
- Revert to libdir for CUPS_SERVERBIN.

* Thu Oct 17 2002 Tim Waugh <twaugh@redhat.com> 1.1.15-11
- Use %%configure for multilib correctness.
- Use libexec instead of lib for CUPS_SERVERBIN.
- Ship translated man pages.
- Remove unshipped files.
- Fix file list permissions (bug #59021, bug #74738).
- Fix messy initscript output (bug #65857).
- Add 'reload' to initscript (bug #76114).

* Fri Aug 30 2002 Bernhard Rosenkraenzer <bero@redhat.de> 1.1.15-10
- Add generic postscript PPD file (#73061)

* Mon Aug 19 2002 Tim Waugh <twaugh@redhat.com> 1.1.15-9
- Fix prefix in pstoraster (bug #69573).

* Mon Aug 19 2002 Tim Waugh <twaugh@redhat.com> 1.1.15-8
- Disable cups-lpd by default (bug #71712).
- No need for fread patch now that glibc is fixed.

* Thu Aug 15 2002 Tim Waugh <twaugh@redhat.com> 1.1.15-7
- Really add cups-lpd xinetd file (bug #63919).
- Ship pstoraster (bug #69573).
- Prevent fread from trying to read from beyond EOF (fixes a segfault
  with new glibc).

* Sat Aug 10 2002 Elliot Lee <sopwith@redhat.com> 1.1.15-6
- rebuilt with gcc-3.2 (we hope)

* Mon Aug  5 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.15-5
- Add cups-lpd xinetd file (#63919)

* Tue Jul 23 2002 Florian La Roche <Florian.LaRoche@redhat.de> 1.1.15-4
- add a "exit 0" to postun script

* Tue Jul  2 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.15-3
- Add a symlink /usr/share/cups/doc -> /usr/share/doc/cups-devel-1.1.15
  because some applications expect to find the cups docs in
  /usr/share/cups/doc

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Fri Jun 21 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.15-1
- 1.1.15-1
- Fix up smb printing trigger (samba-client, not samba-clients)
- Start cupsd earlier, apparently it needs to be running before samba
  starts up for smb printing to work.

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Tue May  7 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.14-17
- Rebuild in current environment
- [-16 never existed because of build system breakage]

* Wed Apr 17 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.14-15
- Fix bug #63387

* Mon Apr 15 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.14-14
- Fix dangling symlink created by samba-clients trigger

* Wed Apr 10 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.14-13
- Add desktop file and icon for CUPS configuration

* Wed Apr  3 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.14-12
- Support SMB printing (#62407)
- Add HTML redirections to doc files to work around users mistaking
  /usr/share/doc/cups-1.1.14 for the web frontend (#62405)

* Tue Apr  2 2002 Bill Nottingham <notting@redhat.com> 1.1.14-11
- fix subsys in initscript (#59206)
- don't strip binaries

* Mon Mar 11 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.14-10
- Make initscript use killproc instead of killall

* Fri Mar  8 2002 Bill Nottingham <notting@redhat.com> 1.1.14-9
- use alternatives --initscript support

* Mon Mar  4 2002 Bill Nottingham <notting@redhat.com> 1.1.14-8
- use the right path for the lpc man page, duh

* Thu Feb 28 2002 Bill Nottingham <notting@redhat.com> 1.1.14-7
- lpc man page is alternative too
- run ldconfig in -libs %post/%postun, not main
- remove alternatives in %preun

* Wed Feb 27 2002 Bill Nottingham <notting@redhat.com> 1.1.14-6
- don't source /etc/sysconfig/network in cups.init, we don't use any
  values from it

* Tue Feb 26 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.14-4
- Fix bugs #60220 and #60352

* Thu Feb 21 2002 Tim Powers <timp@redhat.com>
- rebuild against correct version of openssl (0.9.6b)

* Wed Feb 20 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.14-2
- Add all man pages to alternatives (#59943)
- Update to real 1.1.14

* Tue Feb 12 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.14-1
- Update to almost-1.1.14

* Mon Feb 11 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.13-5
- Move cups-config to cups-devel subpackage
- Make alternatives usage a %%define to simplify builds for earlier
  releases
- Explicitly provide things we're supplying through alternatives
  to shut up kdeutils dependencies

* Tue Feb  5 2002 Tim Powers <timp@redhat.com>
- shut the alternatives stuff up for good

* Fri Feb  1 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.13-3
- Fix alternatives stuff
- Don't display error messages in %%post

* Wed Jan 30 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.13-2
- alternatives stuff

* Tue Jan 29 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.13-1
- 1.1.13
- Add patch for koi8-{r,u} and iso8859-8 encodings (#59018)
- Rename init scripts so we can safely "killall cupsd" from there

* Sat Jan 26 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.12-1
- Initial (conflicting, since alternatives isn't there yet) packaging for
  Red Hat Linux

* Sat Jan 19 2002 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.1.12

* Mon Nov  5 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.10-3
- Compress PPD files
- Fix build with gcc 3.1
- Fix init script

* Tue Sep  4 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.10-2
- Fix URL
- Generate printcap
- s/Copyright/License/g

* Tue Sep  4 2001 Than Ngo <than@redhat.com> 1.1.10-1
- update to 1.1.10-1 for ExtraBinge 7.2

* Tue May 29 2001 Michael Stefaniuc <mstefani@redhat.com>
- update to 1.1.8
- changed cupsd.conf to generate /etc/printcap

* Tue May 15 2001 Than Ngo <than@redhat.com>
- update to 1.1.7, bugfixes

* Thu Dec 14 2000 Than Ngo <than@redhat.com>
- fixed package dependency with lpr and LPRng

* Wed Oct 25 2000 Than Ngo <than@redhat.com>
- remove man/cat

* Tue Oct 24 2000 Than Ngo <than@redhat.com>
- don't start cupsd service in level 0, fixed

* Thu Oct 19 2000 Than Ngo <than@redhat.com>
- update to 1.1.4
- fix CUPS_DOCROOT (Bug #18717)

* Fri Aug 11 2000 Than Ngo <than@redhat.de>
- update to 1.1.2 (Bugfix release)

* Fri Aug 4 2000 Than Ngo <than@redhat.de>
- fix, cupsd read config file under /etc/cups (Bug #15432)
- add missing cups filters

* Wed Aug 2 2000 Tim Powers <timp@redhat.com>
- rebuilt against libpng-1.0.8

* Tue Aug 01 2000 Than Ngo <than@redhat.de>
- fix permission, add missing ldconfig in %post and %postun (Bug #14963)

* Sat Jul 29 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.1.1 (this has some major bugfixes)
- Fix a typo in initscript (it's $?, not ?$)
- Fix /usr/etc vs. /etc trouble, don't insist on /usr/var (YUCK!)
- Create the spool dir

* Fri Jul 28 2000 Than Ngo <than@redhat.de>
- fix unclean code for building against gcc-2.96
- add missing restart function in startup script

* Fri Jul 28 2000 Tim Powers <timp@redhat.com>
- fixed initscript so that conrestart doesn't return 1 if the test fails

* Mon Jul 24 2000 Prospector <prospector@redhat.com>
- rebuilt

* Wed Jul 19 2000 Than Ngo <than@redhat.de>
- using service to fire them up
- fix Prereq section

* Mon Jul 17 2000 Tim Powers <timp@redhat.com>
- added defattr to the devel package

* Sun Jul 16 2000 Than Ngo <than@redhat.de>
- add cups config files

* Sat Jul 15 2000 Than Ngo <than@redhat.de>
- update to 1.1 release
- move back to /etc/rc.d/init.d
- fix cupsd.init to work with /etc/init.d and /etc/rc.d/init.d
- split cups

* Wed Jul 12 2000 Than Ngo <than@redhat.de>
- rebuilt

* Thu Jul 06 2000 Tim Powers <timp@redhat.com>
- fixed broken PreReq to now require /etc/init.d

* Tue Jun 27 2000 Tim Powers <timp@redhat.com>
- PreReq initscripts >= 5.20

* Mon Jun 26 2000 Tim Powers <timp@redhat.com>
- started changelog 
- fixed init.d script location
- changed script in init.d quite a bit and made more like the rest of our
  startup scripts 
